/*-
 * Copyright (C)2012 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2012 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: index.c,v 1.6 2012/08/20 18:49:34 babolo Exp $";
#endif /* not lint */

#include <sys/socket.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/un.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <err.h>
#include <commad.h>

int
main() {
    struct sockaddr_un serv, clint;
    struct timespec time;
    char *o, p[POSTLN];
    commad_resp r;
    ssize_t l;
    int fd;

    printf("Content-Type: text/html; charset=koi8-r\n\n");
    o = getenv("QUERY_STRING");
    if  (o && o[0] && (o[0] < 'a' || o[0] > 'z' || o[1] < '0' || o[1] > '9' || o[2] != 0)) {
        printf("illegal query");
        exit(1);
    }
    bzero(&serv, sizeof(serv));
    strncpy(serv.sun_path, USOCK, sizeof(serv.sun_path));
#ifdef __FreeBSD__
    serv.sun_len = sizeof(serv);
#endif
    serv.sun_family = AF_UNIX;
    bzero(&clint, sizeof(clint));
    strcpy(clint.sun_path, tmpnam(NULL));
#ifdef __FreeBSD__
    clint.sun_len = sizeof(clint);
#endif
    clint.sun_family = AF_UNIX;
    bzero(&r, sizeof(r));
    Q(0 > (fd = socket(AF_UNIX, SOCK_DGRAM, 0)));
    Q(0 > bind(fd, (struct sockaddr *)&clint, sizeof(clint)));
    if  (!o) {
        /*    */
        Q(0 > sendto(fd, &r, 0, MSG_EOR, (struct sockaddr *)&serv, sizeof(serv)));
    } else if (strncmp(o, "c2", 3)) {
        /*     "c2" */
        Q(0 > sendto(fd, o, 2, MSG_EOR, (struct sockaddr *)&serv, sizeof(serv)));
    } else {
        Q(0 > sendto(fd, "c1", 2, MSG_EOR, (struct sockaddr *)&serv, sizeof(serv)));
        Q(0 > (l = recvfrom(fd, &r, sizeof(r), 0, NULL, 0)));
        bzero(p, POSTLN);
        if  (  (0 < read(fileno(stdin), p, POSTLN - 1))
            && (!strncmp("c3=", p, 3))
            && (p[3] == r.p[0])
            && (p[4] == r.p[1])
            && (p[5] == r.p[2])
            ) {
        } else {
            o[1] = '0';
        }
        Q(0 > sendto(fd, o, 2, MSG_EOR, (struct sockaddr *)&serv, sizeof(serv)));
    }
    Q(0 > (l = recvfrom(fd, &r, sizeof(r), 0, NULL, 0)));
    Q(l != sizeof(r));
    printf( "<html>\n"
            "<head>\n"
            " <META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n"
          );
    if  (!o || !o[0]) {
        printf( " <META HTTP-EQUIV=\"Refresh\" CONTENT=\"30\">\n"
              );
    }
    printf( " <title></title>\n"
            "</head>\n"
            "<body>\n"
            " <table>\n"
            "  <tr><td colspan=%d>"
          , DEVSLN
          );
    if  (!o || !o[0]) {
        Q(0 > clock_gettime(CLOCK_REALTIME, &time));
        time.tv_sec %= 86400;
#ifdef __FreeBSD__
        printf( "<font color=\"%s\">%02u:%02u\n"
#else
        printf( "<font color=\"%s\">%02lu:%02lu\n"
#endif
              , ((time.tv_sec % 10) & 1) ? "red" : "green"
              , time.tv_sec / 3600
              , (time.tv_sec / 60 ) % 60
              );
    } else {
        printf("<a href=\"?\"></a>");
    }
    printf( "</td></tr>\n"
            "  <tr><td colspan=%d><img src=\"/h0.gif\" border=\"0\"></td></tr>\n"
            "  <tr>\n"
            "   <td><img src=\"/u0%c.gif\" border=\"0\"></td>\n"
            "   <td><img src=\"/u0%c.gif\" border=\"0\"></td>\n"
            "   <td><img src=\"/u0%c.gif\" border=\"0\"></td>\n"
            "   <td><img src=\"/u0%c.gif\" border=\"0\"></td>\n"
            "  </tr>\n"
            "  <tr>\n"
            "   <td><img src=\"/l%c.gif\" border=\"0\"></td>\n"
            "   <td><img src=\"/l%c.gif\" border=\"0\"></td>\n"
            "   <td><img src=\"/l%c.gif\" border=\"0\"></td>\n"
            "   <td><img src=\"/l%c.gif\" border=\"0\"></td>\n"
            "  </tr>\n"
            "  <tr>\n"
            "   <td><img src=\"/d0%c.gif\" border=\"0\"></td>\n"
            "   <td><img src=\"/d0%c.gif\" border=\"0\"></td>\n"
            "   <td><img src=\"/d0%c.gif\" border=\"0\"></td>\n"
            "   <td><img src=\"/d0%c.gif\" border=\"0\"></td>\n"
            "  </tr>\n"
          , DEVSLN
          , r.u00, r.u01, r.u02, r.u03
          , r.l00, r.l01, r.l02, r.l03
          , r.d00, r.d01, r.d02, r.d03
          );
    if  (r.p[0]) {
        printf( "  <tr><td colspan=%d>\n"
                "    %s\n"
                "   <form method=POST accept-charset=\"koi8-r\" action=\"?c2\">\n"
                "    <input type=text name=\"c3\" size=\"4\">\n"
                "    <input type=submit><input type=reset>\n"
                "   </form>\n"
                "  </td></tr>\n"
              , DEVSLN
              , r.p
              );
    } else {
        printf( "  <tr><td colspan=%d><a href=\"?c0\"><img src=\"/ar.gif\" border=\"0\"></a></td></tr>\n"
              , DEVSLN
              );
    }
    printf( "  <tr><td colspan=%d><img src=\"/h1.gif\" border=\"0\"></td></tr>\n"
            "  <tr>\n"
            "   <td><a href=\"?u0\"><img src=\"/u%c%c.gif\" border=\"0\"></a></td>\n"
            "   <td><a href=\"?u1\"><img src=\"/u%c%c.gif\" border=\"0\"></a></td>\n"
            "   <td><a href=\"?u2\"><img src=\"/u%c%c.gif\" border=\"0\"></a></td>\n"
            "   <td><a href=\"?u3\"><img src=\"/u%c%c.gif\" border=\"0\"></a></td>\n"
            "  </tr>\n"
            "  <tr>\n"
            "   <td><a href=\"?m0\"><img src=\"/l%c.gif\" border=\"0\"></a></td>\n"
            "   <td><a href=\"?m1\"><img src=\"/l%c.gif\" border=\"0\"></a></td>\n"
            "   <td><a href=\"?m2\"><img src=\"/l%c.gif\" border=\"0\"></a></td>\n"
            "   <td><a href=\"?m3\"><img src=\"/l%c.gif\" border=\"0\"></a></td>\n"
            "  </tr>\n"
            "  <tr>\n"
            "   <td><a href=\"?d0\"><img src=\"/d%c%c.gif\" border=\"0\"></a></td>\n"
            "   <td><a href=\"?d1\"><img src=\"/d%c%c.gif\" border=\"0\"></a></td>\n"
            "   <td><a href=\"?d2\"><img src=\"/d%c%c.gif\" border=\"0\"></a></td>\n"
            "   <td><a href=\"?d3\"><img src=\"/d%c%c.gif\" border=\"0\"></a></td>\n"
            "  </tr>\n"
          , DEVSLN
          , (r.sel == (UPSEL | 0)) ? '1' : '0', r.u10
          , (r.sel == (UPSEL | 1)) ? '1' : '0', r.u11
          , (r.sel == (UPSEL | 2)) ? '1' : '0', r.u12
          , (r.sel == (UPSEL | 3)) ? '1' : '0', r.u13
          , r.l10, r.l11, r.l12, r.l13
          , (r.sel == (DWSEL | 0)) ? '1' : '0', r.d10
          , (r.sel == (DWSEL | 1)) ? '1' : '0', r.d11
          , (r.sel == (DWSEL | 2)) ? '1' : '0', r.d12
          , (r.sel == (DWSEL | 3)) ? '1' : '0', r.d13
          );
    printf( " </table>\n"
            "</body>\n"
          );
    exit(0);
}
