/*-
 * Copyright (C)2012 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: commad.h,v 1.3 2012/07/27 10:24:22 babolo Exp $
 */

#ifdef TEST
#define USOCK  "./commad.sock"
#else
#define USOCK  "/var/run/commad.sock"
#endif
#define COMMLN 4
#define POSTLN 20
#define PASSLN 3
#define DEVSLN 4
#define Q(O) do {if ((O)) err(1, " at %d", __LINE__);} while(0)

typedef struct commad_resp {
    char u00, u01, u02, u03;
    char l00, l01, l02, l03;
    char d00, d01, d02, d03;
    union {
        char u1[DEVSLN];
        struct {
            char u10, u11, u12, u13;
    };  };
    union {
        char l1[DEVSLN];
        struct {
            char l10, l11, l12, l13;
    };  };
    union {
        char d1[DEVSLN];
        struct {
            char d10, d11, d12, d13;
    };  };
    char p[COMMLN];
    u_char sel;
#   define NMASK 0x03
#   define LMASK 0x0C
#   define UPSEL 0x04
#   define DWSEL 0x08
} commad_resp;
