/*-
 * Copyright (C)2012 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2012 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: commad.c,v 1.6 2012/08/25 10:03:46 babolo Exp $";
#endif /* not lint */

#include <sys/socket.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/un.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <stdio.h>
#include <err.h>
#include <commad.h>

static void
getrnd(char *o) {
    long wt;
    int fd;

    if  (0 > (fd = open("/dev/random", O_RDONLY))) goto out;
    if  (0 > read(fd, &wt, sizeof(wt))) goto out;
    close(fd);
    wt &= 0x7FFFFFFF;
    wt %= 1000; /* 10 ^ PASSLN */
    o[0] = '0' + wt % 10;
    wt /= 10;
    o[1] = '0' + wt % 10;
    wt /= 10;
    o[2] = '0' + wt % 10;
    o[3] = 0;
out:;
}

static void
rplace(commad_resp *r, u_char o1) {
    char t;

    t = r->d1[r->sel & NMASK];
    r->d1[r->sel & NMASK] = r->d1[o1];
    r->d1[o1] = t;
    r->sel = 0;
}

int
main() {
    struct sockaddr_un serv, clint;
    char o[PASSLN + 1];
    commad_resp r;
    socklen_t y;
    ssize_t l;
    u_char o1;
    int fd;

    bcopy("0123000001230123000001230\000\000\000\000", &r, sizeof(r));
    unlink(USOCK);
    Q(0 > (fd = socket(AF_UNIX, SOCK_DGRAM, 0)));
    bzero(&serv, sizeof(serv));
    strncpy(serv.sun_path, USOCK, sizeof(serv.sun_path));
#ifdef __FreeBSD__
    serv.sun_len = sizeof(serv);
#endif
    serv.sun_family = AF_UNIX;
    Q(0 > bind(fd, (struct sockaddr *)&serv, sizeof(serv)));
    Q(0 > chmod(USOCK, S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH));
    bzero(r.p, COMMLN);
#ifndef TEST
    Q(0 > daemon(0, 0));
#endif
    for (;;) {
        y = sizeof(clint);
        l = recvfrom(fd, o, COMMLN, 0, (struct sockaddr *)&clint, &y);
        o1 = o[1] - '0';
        if  ((l != 2) || (o[1] < '0') || (o1 >= DEVSLN)) o[0] = 0;
        switch (o[0]) {
        case 'u':
            if  (!(r.sel & DWSEL)) {
                r.sel = o1 | UPSEL;
            } else {
                rplace(&r, o1);
            }
            bzero(r.p, COMMLN);
            break;
        case 'm':
            r.l1[o1] ^= 1;
            bzero(r.p, COMMLN);
            break;
        case 'd':
            if  (!(r.sel & UPSEL)) {
                r.sel = o1 | DWSEL;
            } else {
                rplace(&r, o1);
            }
            bzero(r.p, COMMLN);
            break;
        case 'c':
            switch (o1) {
            case 0:
                getrnd(r.p);
            case 1:
                break;
            case 2:
                bcopy(&r.u10, &r, 12);
                bzero(r.p, COMMLN);
                break;
            }
            break;
        default:
            bzero(r.p, COMMLN);
        }
        sendto(fd, &r, sizeof(r), 0, (struct sockaddr *)&clint, y);
    }
    exit(1);
}
